/* 服务启动主入口 */


/* ------PART_1:通用服务------ */

/* 1-1. pg数据库服务（基础类） */
const pgBaseRouter = require("./public/PgBase/pgBaseRouter.js");
const SearchRouter = require('./module/Search/SearchRouter.js')


/* ------PART_2:项目服务------ */

/* 2-1. POI模块 */
const POIRouter = require("./module/POI/poiRouter.js")
/* 2-2. 倾斜数据管理（模块） */
const QxManagerRouter = require("./module/QxManager/qxManagerRouter.js")
/* 2-3. 用户管理模块 */
const userManageRouter = require("./module/UserManage/userManageRouter.js")
/* 2-4. 单体化模块 */
const DanTiHuaRouter = require("./module/DanTiHua/DTHRouter.js")

// 启动服务
function startServer(app, express) {

    /** PART1 通用服务(public) 
     * 示例：app.use(/public/模块名)
     * 示例：app.use("/public/user")  公共模块/用户管理模块  
     */

    /* 1-1. pg数据库服务（基础类） */
    app.use("/public/pgBase", pgBaseRouter)
    /* 1-2 查询服务（空间查询） */
    app.use("/search", SearchRouter)



    /** PART2 项目服务(project) 
     * 示例：app.use("/模块名")
     * 示例：app.use("/qs")  黄河项目/资源管理模块  
     */

    /* 2.1 POI 搜索、分类 */
    app.use("/poi", POIRouter);
    /* 2.2 qx 倾斜数据管理 */
    app.use("/qx", QxManagerRouter);

    /* 2.4 单体化模块 */
    app.use("/dth", DanTiHuaRouter);

    /* 2.3 userManage 用户管理模块 */
    app.use("/userManage", userManageRouter);



}

module.exports = startServer;