const pgPool = require("./pgInit.js")

// 执行sql语句
function execute(sql) {
    return new Promise(function (resolve, reject) {

        pgPool.connect(function (err, client, release) {
            if (err) {
                console.error('数据库连接失败:' + err.message);
                reject(err);
                return;
            }

            client.query(sql, (err, result) => {
                // 释放连接
                release();
                if (err) {
                    console.error('查询失败:' + err.message);
                    reject(err);
                } else {
                    resolve(result)
                }
            })
        });
    });
}

const pgClient = {
    execute: execute,
    query: execute,
    pool: pgPool
}
module.exports = pgClient;