 const pgClient = require("../../../core/pgClient/pgClient.js")
// 空间查询
const SimpleGeoSpatialQueryDao = require("./SimpleGeoSpatialQueryDao.js")


/* 浮游植物（藻类）Service */
class SimpleGeoSpatialQueryService {
    constructor() {
        this.simpleGeoSpatialQueryDao = new SimpleGeoSpatialQueryDao()
     }


    /* 1. 空间查询:（1）普通空间查询、（2）缓冲区查询 */
    async SimpleGeoSpatialQuery(param) {
        let dataResult = {}
        let queryType = param.queryType
        let tbName = param.tbName
        let WKTstr = param.WKTstr
        let startTime = param.startTime || ''
        let endTime = param.endTime || ''
        let fieldsArr = param.fieldsArr || []
        let where_condition = param.where_condition || ''
        // 缓冲区用的
        let distance = param.distance || 40
       // 提取普通空间查询的逻辑
       if (queryType === 'line' || queryType === 'polyline' || queryType === 'polygon' || queryType === 'rectangle' || queryType === 'point') {
        dataResult = await this.simpleGeoSpatialQueryDao.ST_DWithin(tbName, WKTstr, distance, startTime, endTime, fieldsArr, where_condition)
       } else if (queryType === 'buffer' || queryType === 'point_buffer' || queryType === 'polyline_buffer' || queryType === 'polygon_buffer' || queryType === 'rectangle_buffer') {
        dataResult = await this.simpleGeoSpatialQueryDao.ST_DWithin(tbName, WKTstr, distance, startTime, endTime, fieldsArr, where_condition)
       }


        // 获取字段以及备注名称
        let tbAttrObj = await this.getAttrsByTableName(param.tbName);

        // dataResult:是空间查询的结果
        // tbAttrObj：是表字段及备注结果
        let result = {
            dataResult: dataResult,
            attrResult: tbAttrObj
        }



        return result
    }


    /* 2. listGeom 获取全部矢量数据（仅有geom） */
    async listGeom() {
        let tbName = param.tbName;
        let result = await this.simpleGeoSpatialQueryDao.listGeom(tbName)
        return result;
    }


    /* tool1. 获取表的属性以及备注名称 */
    async getAttrsByTableName(tableName) {
        let sql = `SELECT a.attnum, a.attname AS field, t.typname AS type, a.attlen AS length, a.atttypmod AS lengthvar
    	, a.attnotnull AS notnull, b.description AS desc
	FROM pg_class c, pg_attribute a
    	LEFT JOIN pg_description b
    	ON a.attrelid = b.objoid
        	AND a.attnum = b.objsubid, pg_type t
	WHERE c.relname = '${tableName}'
    	AND a.attnum > 0
    	AND a.attrelid = c.oid
    	AND a.atttypid = t.oid
	ORDER BY a.attnum;`

        let result = pgClient.query(sql)

        return result
    }


}


module.exports = SimpleGeoSpatialQueryService;